diff --git a/src/main/java/net/minecraft/core/block/BlockTorch.java b/src/main/java/net/minecraft/core/block/BlockTorch.java
index 9f584b832..b099736fc 100644
--- a/src/main/java/net/minecraft/core/block/BlockTorch.java
+++ b/src/main/java/net/minecraft/core/block/BlockTorch.java
@@ -13,10 +13,6 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, World, AxisAlignedBB, 
-//            Vec3D, MovingObjectPosition
-
 public class BlockTorch extends Block
 {
     public static final int MASK_DIRECTION = 0b0000_0111;
diff --git a/src/main/java/net/minecraft/core/block/BlockWireRedstone.java b/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
index b219e694c..d67503682 100644
--- a/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
+++ b/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
@@ -126,8 +126,7 @@ public class BlockWireRedstone extends Block {
                 if (world.isBlockNormalCube(xi, y0, zi)) {
                     yi += 2;
                 }
-                int targetStrength = 0;
-                targetStrength = checkTarget(world, xi, y0, zi, -1);
+                int targetStrength = checkTarget(world, xi, y0, zi, -1);
                 newStrength = world.getBlockMetadata(x0, y0, z0);
                 if (newStrength > 0) {
                     newStrength--;
diff --git a/src/main/java/net/minecraft/core/block/BlockWorkbench.java b/src/main/java/net/minecraft/core/block/BlockWorkbench.java
index 9fd2a1763..19540ea0e 100644
--- a/src/main/java/net/minecraft/core/block/BlockWorkbench.java
+++ b/src/main/java/net/minecraft/core/block/BlockWorkbench.java
@@ -1,8 +1,5 @@
 package net.minecraft.core.block;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, World, Player
-
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.material.Material;
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index 85f29fc2e..41ff5a94d 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -8,6 +8,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.ICarriable;
@@ -102,13 +103,13 @@ public class TileEntity implements ICarriable
 
     public void writeToNBT(CompoundTag nbttagcompound)
     {
-        String name = TileEntityDispatcher.getIDFromClass(getClass());
+        NamespaceID name = TileEntityDispatcher.getIDFromClass(getClass());
         if(name == null)
         {
             throw new RuntimeException(getClass() + " is missing a mapping! This is a bug!");
         } else
         {
-            nbttagcompound.putString("id", name);
+            nbttagcompound.putString("id", name.toString());
             nbttagcompound.putInt("x", x);
             nbttagcompound.putInt("y", y);
             nbttagcompound.putInt("z", z);
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 3b7846a7b..3b69525d4 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -1,10 +1,5 @@
 package net.minecraft.core.block.entity;
 
-
-// Referenced classes of package net.minecraft.src:
-//            TileEntity, IInventory, ItemStack, NBTTagCompound,
-//            NBTTagList, World, Player
-
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockChest;
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
index d28ff8a4b..97f5d0948 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block.entity;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
+import net.minecraft.core.util.collection.NamespaceID;
 import org.slf4j.Logger;
 
 import java.util.HashMap;
@@ -11,75 +12,133 @@ import java.util.Map;
 public class TileEntityDispatcher {
     private static final Logger LOGGER = LogUtils.getLogger();
 
-    private static final Map<String, Class<? extends TileEntity>> nameToClassMap = new HashMap<>();
-    private static final Map<Class<? extends TileEntity>, String> classToNameMap = new HashMap<>();
+    private static final Map<NamespaceID, Class<? extends TileEntity>> idToClassMap = new HashMap<>();
+    private static final Map<String, Class<? extends TileEntity>> stringToClassMap = new HashMap<>();
+    private static final Map<Class<? extends TileEntity>, NamespaceID> classToIdMap = new HashMap<>();
 
-    public static void addMapping(Class<? extends TileEntity> entityClass, String name)
-    {
-        if(nameToClassMap.containsKey(name))
-        {
-            throw new IllegalArgumentException("Duplicate id: " + name);
-        } else
-        {
-            nameToClassMap.put(name, entityClass);
-            classToNameMap.put(entityClass, name);
+    public static void addMapping(Class<? extends TileEntity> entityClass, NamespaceID id) {
+        if(idToClassMap.containsKey(id)) {
+            throw new IllegalArgumentException("Duplicate id: " + id);
         }
+
+        idToClassMap.put(id, entityClass);
+        stringToClassMap.put(id.toString(), entityClass);
+        classToIdMap.put(entityClass, id);
     }
 
-    public static TileEntity createAndLoadEntity(CompoundTag nbttagcompound)
+    public static TileEntity createAndLoadEntity(CompoundTag compoundTag)
     {
         TileEntity tileEntity = null;
-        Class<? extends TileEntity> entityClass = nameToClassMap.get(nbttagcompound.getString("id"));
-        try
-        {
-            if(entityClass != null)
-            {
+        Class<? extends TileEntity> entityClass = getClassFromID(compoundTag.getString("id"));
+        try {
+            if(entityClass != null) {
                 tileEntity = entityClass.newInstance();
             }
         }
-        catch(Exception exception)
-        {
+        catch(Exception exception) {
             LOGGER.error("Exception when instancing class '{}'!", entityClass.getSimpleName(), exception);
         }
-        if(tileEntity != null)
-        {
-            tileEntity.readFromNBT(nbttagcompound);
-        } else
-        {
-            LOGGER.warn("Skipping TileEntity with id {}", nbttagcompound.getString("id"));
+        if(tileEntity != null) {
+            tileEntity.readFromNBT(compoundTag);
+        } else {
+            LOGGER.warn("Skipping TileEntity with id {}", compoundTag.getString("id"));
         }
         return tileEntity;
     }
 
     public static Class<? extends TileEntity> getClassFromID(String id)
     {
-        return nameToClassMap.get(id);
+        if (Legacy.isLegacyKey(id)) {
+            return Legacy.getClassFromID(id);
+        }
+        return stringToClassMap.get(id);
     }
 
-    public static String getIDFromClass(Class<? extends TileEntity> clazz)
+    public static Class<? extends TileEntity> getClassFromID(NamespaceID id)
     {
-        return classToNameMap.get(clazz);
+        return idToClassMap.get(id);
     }
 
-    static
+    public static NamespaceID getIDFromClass(Class<? extends TileEntity> clazz)
     {
-        // TODO make these ids namespaced
-        addMapping(TileEntityFurnace.class, "Furnace");
-        addMapping(TileEntityChest.class, "Chest");
-        addMapping(TileEntityJukebox.class, "RecordPlayer");
-        addMapping(TileEntityDispenser.class, "Trap");
-        addMapping(TileEntityActivator.class, "Activator");
-        addMapping(TileEntitySign.class, "Sign");
-        addMapping(TileEntityMobSpawner.class, "MobSpawner");
-        addMapping(TileEntityNoteblock.class, "Music");
-        addMapping(TileEntityMovingPistonBlock.class, "Piston");
-        addMapping(TileEntityFurnaceBlastFurnace.class, "BlastFurnace");
-        addMapping(TileEntitySensor.class, "Sensor");
-        addMapping(TileEntityTrommel.class, "Trommel");
-        addMapping(TileEntityBasket.class, "Basket");
-        addMapping(TileEntityFlag.class, "Flag");
-        addMapping(TileEntitySeat.class, "Seat");
-        addMapping(TileEntityFlowerJar.class, "FlowerJar");
-        addMapping(TileEntityMeshGold.class, "MeshGold");
+        return classToIdMap.get(clazz);
+    }
+
+    private static boolean hasInit = false;
+    public static void init() {
+        if (hasInit) return;
+        hasInit = true;
+        addMapping(TileEntityFurnace.class, new NamespaceID("minecraft", "furnace"));
+        addMapping(TileEntityChest.class, new NamespaceID("minecraft", "chest"));
+        addMapping(TileEntityJukebox.class, new NamespaceID("minecraft", "jukebox"));
+        addMapping(TileEntityDispenser.class, new NamespaceID("minecraft", "dispenser"));
+        addMapping(TileEntityActivator.class, new NamespaceID("minecraft", "activator"));
+        addMapping(TileEntitySign.class, new NamespaceID("minecraft", "sign"));
+        addMapping(TileEntityMobSpawner.class, new NamespaceID("minecraft", "mob_spawner"));
+        addMapping(TileEntityMovingPistonBlock.class, new NamespaceID("minecraft", "piston_moving"));
+        addMapping(TileEntityFurnaceBlastFurnace.class, new NamespaceID("minecraft", "furnace_blast"));
+        addMapping(TileEntitySensor.class, new NamespaceID("minecraft", "sensor"));
+        addMapping(TileEntityTrommel.class, new NamespaceID("minecraft", "trommel"));
+        addMapping(TileEntityBasket.class, new NamespaceID("minecraft", "basket"));
+        addMapping(TileEntityFlag.class, new NamespaceID("minecraft", "flag"));
+        addMapping(TileEntitySeat.class, new NamespaceID("minecraft", "seat"));
+        addMapping(TileEntityFlowerJar.class, new NamespaceID("minecraft", "jar_flower"));
+        addMapping(TileEntityMeshGold.class, new NamespaceID("minecraft", "mesh_gold"));
+    }
+
+    @Deprecated
+    public static class Legacy {
+
+        private static final Map<String, Class<? extends TileEntity>> nameToClassMap = new HashMap<>();
+        private static final Map<Class<? extends TileEntity>, String> classToNameMap = new HashMap<>();
+
+        @Deprecated
+        public static Class<? extends TileEntity> getClassFromID(String id)
+        {
+            return nameToClassMap.get(id);
+        }
+        @Deprecated
+        public static String getIDFromClass(Class<? extends TileEntity> clazz)
+        {
+            return classToNameMap.get(clazz);
+        }
+
+        @Deprecated
+        public static void addMapping(Class<? extends TileEntity> entityClass, String name)
+        {
+            if(nameToClassMap.containsKey(name))
+            {
+                throw new IllegalArgumentException("Duplicate id: " + name);
+            } else
+            {
+                nameToClassMap.put(name, entityClass);
+                classToNameMap.put(entityClass, name);
+            }
+        }
+
+        public static boolean isLegacyKey(String id) {
+            return nameToClassMap.containsKey(id);
+        }
+
+        static
+        {
+            addMapping(TileEntityFurnace.class, "Furnace");
+            addMapping(TileEntityChest.class, "Chest");
+            addMapping(TileEntityJukebox.class, "RecordPlayer");
+            addMapping(TileEntityDispenser.class, "Trap");
+            addMapping(TileEntityActivator.class, "Activator");
+            addMapping(TileEntitySign.class, "Sign");
+            addMapping(TileEntityMobSpawner.class, "MobSpawner");
+            addMapping(TileEntityNoteblock.class, "Music");
+            addMapping(TileEntityMovingPistonBlock.class, "Piston");
+            addMapping(TileEntityFurnaceBlastFurnace.class, "BlastFurnace");
+            addMapping(TileEntitySensor.class, "Sensor");
+            addMapping(TileEntityTrommel.class, "Trommel");
+            addMapping(TileEntityBasket.class, "Basket");
+            addMapping(TileEntityFlag.class, "Flag");
+            addMapping(TileEntitySeat.class, "Seat");
+            addMapping(TileEntityFlowerJar.class, "FlowerJar");
+            addMapping(TileEntityMeshGold.class, "MeshGold");
+        }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 931c4e392..f0bed94c0 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -1,11 +1,5 @@
 package net.minecraft.core.block.entity;
 
-
-// Referenced classes of package net.minecraft.src:
-//            TileEntity, IInventory, ItemStack, NBTTagCompound,
-//            NBTTagList, World, BlockFurnace, FurnaceRecipes,
-//            Item, Block, Material, Player
-
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java b/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java
index 5d29ca1ba..2a7200eee 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlastFurnace.java
@@ -1,11 +1,5 @@
 package net.minecraft.core.block.entity;
 
-
-// Referenced classes of package net.minecraft.src:
-//            TileEntity, IInventory, ItemStack, NBTTagCompound,
-//            NBTTagList, World, BlockFurnace, FurnaceRecipes,
-//            Item, Block, Material, Player
-
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.BlockFurnaceBlast;
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java b/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
index 6fade50a7..2dac646f2 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
@@ -1,9 +1,5 @@
 package net.minecraft.core.block.entity;
 
-
-// Referenced classes of package net.minecraft.src:
-//            TileEntity, NBTTagCompound
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.item.ItemStack;
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index d24f2fdea..aeaebe6df 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -25,9 +25,8 @@ public class TileEntityMobSpawner extends TileEntity
 
     public TileEntityMobSpawner()
     {
-        delay = -1;
         yaw2 = 0.0D;
-        mobId = "Pig";
+        mobId = "minecraft:pig";
         delay = 20;
     }
 
@@ -43,6 +42,13 @@ public class TileEntityMobSpawner extends TileEntity
     	} else {
     		this.mobId = mobId;
     	}
+        try {
+            if (EntityDispatcher.Legacy.isLegacyKey(mobId)) {
+                this.mobId = EntityDispatcher.idForClass(EntityDispatcher.Legacy.getClassFromEncodeID(mobId)).toString();
+            }
+        } catch (Exception e) {
+            LOGGER.error("Failed to convert legacy mobspawner id!", e);
+        }
     }
 
     public boolean anyPlayerInRange()
@@ -93,22 +99,13 @@ public class TileEntityMobSpawner extends TileEntity
             byte byte0 = 4;
             for(int i = 0; i < byte0; i++)
             {
-                Mob entityliving = null;
-                
-                if(mobId.equalsIgnoreCase("random")) {
-                	List<SpawnListEntry> list = worldObj.getBlockBiome(x, y, z).getSpawnableList(MobCategory.monster);
-                	
-                	SpawnListEntry entry = list.get(worldObj.rand.nextInt(list.size()));
-                	entityliving = (Mob) EntityDispatcher.createEntityInWorld(EntityDispatcher.classToKeyMap.get(entry.entityClass), worldObj);
-                }else {
-                	entityliving = (Mob) EntityDispatcher.createEntityInWorld(mobId, worldObj);
-                }
-                
-                if(entityliving == null)
+                Mob mob = (Mob) EntityDispatcher.createEntityInWorld(mobId, worldObj);
+
+                if(mob == null)
                 {
                     return;
                 }
-                int j = worldObj.getEntitiesWithinAABB(entityliving.getClass(), AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1).grow(8D, 4D, 8D)).size();
+                int j = worldObj.getEntitiesWithinAABB(mob.getClass(), AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1).grow(8D, 4D, 8D)).size();
                 if(j >= 6)
                 {
                     updateDelay();
@@ -117,13 +114,13 @@ public class TileEntityMobSpawner extends TileEntity
                 double d6 = (double) x + (worldObj.rand.nextDouble() - worldObj.rand.nextDouble()) * 4D;
                 double d7 = (y + worldObj.rand.nextInt(3)) - 1;
                 double d8 = (double) z + (worldObj.rand.nextDouble() - worldObj.rand.nextDouble()) * 4D;
-                entityliving.moveTo(d6, d7, d8, worldObj.rand.nextFloat() * 360F, 0.0F);
-                if(!entityliving.canSpawnHere())
+                mob.moveTo(d6, d7, d8, worldObj.rand.nextFloat() * 360F, 0.0F);
+                if(!mob.canSpawnHere())
                 {
                 	updateDelay();
                     continue;
                 }
-                worldObj.entityJoinedWorld(entityliving);
+                worldObj.entityJoinedWorld(mob);
                 for(int k = 0; k < 20; k++)
                 {
                     double d1 = (double) x + 0.5D + ((double)worldObj.rand.nextFloat() - 0.5D) * 2D;
@@ -131,10 +128,10 @@ public class TileEntityMobSpawner extends TileEntity
                     double d5 = (double) z + 0.5D + ((double)worldObj.rand.nextFloat() - 0.5D) * 2D;
                     worldObj.spawnParticle("smoke", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
                     worldObj.spawnParticle("flame", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
-                    worldObj.playSoundAtEntity(null, entityliving, "mob.ghast.fireball", 0.025F, 0.75F);
+                    worldObj.playSoundAtEntity(null, mob, "mob.ghast.fireball", 0.025F, 0.75F);
                 }
 
-                entityliving.spawnExplosionParticle();
+                mob.spawnExplosionParticle();
                 updateDelay();
             }
 
@@ -145,7 +142,7 @@ public class TileEntityMobSpawner extends TileEntity
     @Override
 	public Packet getDescriptionPacket()
     {
-        return new SetMobSpawnerPacket(x, y, z, mobId);
+        return new SetMobSpawnerPacket(x, y, z, EntityDispatcher.classForId(mobId));
     }
     
     public int countNearbySpawners() {
diff --git a/src/main/java/net/minecraft/core/block/material/MaterialDecoration.java b/src/main/java/net/minecraft/core/block/material/MaterialDecoration.java
index cff0d9a52..d4bbf16ba 100644
--- a/src/main/java/net/minecraft/core/block/material/MaterialDecoration.java
+++ b/src/main/java/net/minecraft/core/block/material/MaterialDecoration.java
@@ -1,9 +1,5 @@
 package net.minecraft.core.block.material;
 
-
-// Referenced classes of package net.minecraft.src:
-//            Material, MapColor
-
 public class MaterialDecoration extends Material
 {
 
diff --git a/src/main/java/net/minecraft/core/block/material/MaterialGas.java b/src/main/java/net/minecraft/core/block/material/MaterialGas.java
index 3efb73a86..7de208ac0 100644
--- a/src/main/java/net/minecraft/core/block/material/MaterialGas.java
+++ b/src/main/java/net/minecraft/core/block/material/MaterialGas.java
@@ -1,9 +1,5 @@
 package net.minecraft.core.block.material;
 
-
-// Referenced classes of package net.minecraft.src:
-//            Material, MapColor
-
 public class MaterialGas extends Material
 {
 
diff --git a/src/main/java/net/minecraft/core/block/material/MaterialLiquid.java b/src/main/java/net/minecraft/core/block/material/MaterialLiquid.java
index 144a11813..19e98389a 100644
--- a/src/main/java/net/minecraft/core/block/material/MaterialLiquid.java
+++ b/src/main/java/net/minecraft/core/block/material/MaterialLiquid.java
@@ -1,9 +1,5 @@
 package net.minecraft.core.block.material;
 
-
-// Referenced classes of package net.minecraft.src:
-//            Material, MapColor
-
 public class MaterialLiquid extends Material
 {
 
diff --git a/src/main/java/net/minecraft/core/block/material/MaterialPortal.java b/src/main/java/net/minecraft/core/block/material/MaterialPortal.java
index 8d2c8a165..3cfb75cac 100644
--- a/src/main/java/net/minecraft/core/block/material/MaterialPortal.java
+++ b/src/main/java/net/minecraft/core/block/material/MaterialPortal.java
@@ -1,9 +1,5 @@
 package net.minecraft.core.block.material;
 
-
-// Referenced classes of package net.minecraft.src:
-//            Material, MapColor
-
 public class MaterialPortal extends Material
 {
 
diff --git a/src/main/java/net/minecraft/core/crafting/ContainerListener.java b/src/main/java/net/minecraft/core/crafting/ContainerListener.java
index 509c1ec3d..4fa274868 100644
--- a/src/main/java/net/minecraft/core/crafting/ContainerListener.java
+++ b/src/main/java/net/minecraft/core/crafting/ContainerListener.java
@@ -5,9 +5,6 @@ import net.minecraft.core.player.inventory.menu.MenuAbstract;
 
 import java.util.List;
 
-// Referenced classes of package net.minecraft.src:
-//            Container, ItemStack
-
 public interface ContainerListener
 {
     void updateCraftingInventory(MenuAbstract container, List<ItemStack> list);
diff --git a/src/main/java/net/minecraft/core/crafting/LookupFuelFurnaceBlast.java b/src/main/java/net/minecraft/core/crafting/LookupFuelFurnaceBlast.java
index aea76c956..d47da7159 100644
--- a/src/main/java/net/minecraft/core/crafting/LookupFuelFurnaceBlast.java
+++ b/src/main/java/net/minecraft/core/crafting/LookupFuelFurnaceBlast.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.crafting;
 
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 
 public class LookupFuelFurnaceBlast extends LookupFuelFurnace {
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryBlastFurnace.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryBlastFurnace.java
index 90e56107c..abed164d7 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryBlastFurnace.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryBlastFurnace.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
-import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.*;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeBlastFurnaceJsonAdapter;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryFurnace.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryFurnace.java
index 1def3d2c7..ad678bea3 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryFurnace.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryFurnace.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
-import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.*;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeFurnaceJsonAdapter;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryTrommel.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryTrommel.java
index 5d08877bb..ae50b7086 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryTrommel.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryTrommel.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
-import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.data.registry.Registries;
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index 920554ffc..9a4ebc534 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -4,6 +4,7 @@ import java.util.List;
 import java.util.Random;
 
 import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.ICarriable;
 import org.jetbrains.annotations.Nullable;
@@ -13,7 +14,6 @@ import com.mojang.nbt.DoubleTag;
 import com.mojang.nbt.FloatTag;
 import com.mojang.nbt.ListTag;
 
-import net.minecraft.client.gui.guidebook.mobs.MobInfoRegistry;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
@@ -1030,14 +1030,14 @@ public abstract class Entity
 
     public boolean save(CompoundTag tag)
     {
-        String s = getEncodeId();
+        NamespaceID s = getEncodeId();
         if(removed || s == null)
         {
             return false;
         }
         else
         {
-            tag.putString("id", s);
+            tag.putString("id", s.toString());
             saveWithoutId(tag);
             return true;
         }
@@ -1092,9 +1092,9 @@ public abstract class Entity
         readAdditionalSaveData(tag);
     }
 
-    protected final String getEncodeId()
+    protected final NamespaceID getEncodeId()
     {
-        return EntityDispatcher.getEncodeId(this);
+        return EntityDispatcher.idForClass(this.getClass());
     }
 
     public abstract void readAdditionalSaveData(CompoundTag tag);
@@ -1512,11 +1512,11 @@ public abstract class Entity
         if (entity instanceof Player){
             return ((Player) entity).getDisplayName();
         }
-        if (MobInfoRegistry.getMobInfo(entity.getClass()) != null){
-            return translator.translateKey(MobInfoRegistry.getMobInfo(entity.getClass()).getNameTranslationKey());
+        if (EntityDispatcher.nameKeyForClass(entity.getClass()) != null){
+            return translator.translateKey(EntityDispatcher.nameKeyForClass(entity.getClass()));
         }
-        String dispatcherName = EntityDispatcher.getEncodeId(entity);
-        if (dispatcherName != null) return dispatcherName;
+        NamespaceID dispatcherId = EntityDispatcher.idForClass(entity.getClass());
+        if (dispatcherId != null) return dispatcherId.value;
         return entity.getClass().getSimpleName();
     }
 }
